Improved 3D model shaders
Status: Closed Start date: 2013-10-12
Priority: Normal % Done: 100%
Assignee: skyjake
Category: Enhancement
Target version: 2.0 — Home Ul & Packages
Description
The new 3D model shading need some improvements:
[ ] MW I i -
¢ Provide-moedel-vertex-colors-as-a-vertex-atiribute-to-the-shader
* Fog-
Related issues:
Related to Feature #2105: Manually created reflection cube maps for models Closed 2015-07-29
Related to Feature #1623: Shaders Progressed  2013-03-01
Follows Feature #8: New GL2 based model renderer Closed 2013-10-11

Associated revisions

Revision 79570cab - 2015-12-06 22:55 - skyjake

Model Renderer|Shaders: Multiply vertex color into diffuse texture color

The general-purpose shaders in renderer.pack now multiply aColor into
the color from the diffuse texture map.

IssuelD #1995
Revision 637ac102 - 2015-12-18 11:29 - skyjake
Renderer|Shaders: "model.skeletal.generic” supports uMapTime, custom UV macro

The generic shader can now be customized with predefined macros.
The PREDEF_TRANSFORM_UV() macro is called before texel lookup.

uMapTime is available for use in the shader, although the default
implementation does not use it for anything.

IssuelD #1995

Revision 14dce08c - 2015-12-26 21:40 - skyjake
Renderer|Shaders: Added a GLSL include file for reflection cube maps
IssuelD #1995

Revision 20d2343c - 2015-12-26 21:44 - skyjake

Model Renderer: Added a shared reflection cube map

For now all models will share the same reflection cube map.
IssuelD #1995

Revision ea8ee37d - 2015-12-28 21:14 - skyjake
Renderer|Shaders: Incorporate reflection map to shaders
All generic shaders now support reflection mapping.
Revision 1982d6bd - 2015-12-28 22:01 - skyjake

Model Renderer: Use /home/cubemap.jpg as the reflection cube map

For testing purposes, check for "cubemap.jpg" in the runtime folder
and use it as the reflection cube map.

IssuelD #1995

History

#1 - 2015-03-13 09:09 - skyjake
- Tags changed from 3DModel to 3DModel, OpenGL, Renderer

- Subject changed from 3D model shaders to Improved 3D model shaders

#2 - 2015-03-13 09:10 - skyjake

- Follows Feature #8: New GL2 based model renderer added

#3 - 2015-03-13 09:11 - skyjake
- Due date deleted (2013-10-12)

#4 - 2015-04-22 04:24 - danij
- Target version deleted (42)

#5 - 2015-07-29 14:28 - skyjake

- Target version set to 2.0 — Home Ul & Packages

#6 - 2015-07-29 14:32 - skyjake

- Related to Feature #2105: Manually created reflection cube maps for models added

#7 - 2015-08-27 15:55 - skyjake

- Description updated

#8 - 2015-11-03 09:16 - skyjake
- Status changed from New to In Progress

- % Done changed from 0 to 20

There can now be a different shader for each rendering pass of a model.

#9 - 2015-11-10 11:33 - skyjake
- % Done changed from 20 to 40

Fog is now implemented for 3D models (in renderer.pack/include/fog.glsl).

#10 - 2015-11-24 19:31 - skyjake
- Related to Feature #1623: Shaders added

#11 - 2015-12-06 22:55 - skyjake
- % Done changed from 40 to 60

Model vertex colors are now read from the model file and provided as an attribute named aColor.

#12 - 2015-12-06 22:56 - skyjake
- Description updated

#13 - 2015-12-26 22:52 - skyjake
- % Done changed from 60 to 80

The shader functions for reflection cube maps have now been implemented. The next step is integrating the reflection as part of

"model.skeletal.generic".
#14 - 2015-12-29 10:15 - skyjake
- Status changed from In Progress to Resolved

- % Done changed from 80 to 100

#15 - 2015-12-29 10:15 - skyjake

- Description updated

#16 - 2015-12-29 10:16 - skyjake

- Status changed from Resolved to Closed
